#include <windows.h>
#include <stdlib.h>
#include <iostream>
#include <list>
#include <string>

using namespace std;

union FTime {
	FILETIME ft;
	long long lv;
};

list<string> sli;
list<wstring> wsli;
list<int> ili;

typedef void (*BmProc)(void);

void bm_sort()
{
	sli.sort();
}

void bm_wsort()
{
	wsli.sort();
}

void bm_isort()
{
	ili.sort();
}

void RandString(int irand, wstring &srnd)
{
	const int CM = 50, NC = 200, NMAX = NC+CM;
	srnd.resize(256);
	int j = 0;
	while (irand != 0) {
		srnd[j] = (wchar_t)(irand % NC + CM);
		++j;
		irand = irand / NC;
	}
}

void RandSString(int irand, string &srnd)
{
	const int CM = 50, NC = 200, NMAX = NC+CM;
	srnd.resize(256);
	int j = 0;
	while (irand != 0) {
		srnd[j] = (char)(irand % NC + CM);
		++j;
		irand = irand / NC;
	}
}

void RunOne(BmProc prc, const char *name, int l)
{
	FTime t0, t1;
	GetSystemTimeAsFileTime(&t0.ft);
	(*prc)();
	GetSystemTimeAsFileTime(&t1.ft);
	std::cout << name << " t=" << (t1.lv-t0.lv)/10 << " mcs size=" << sli.size() << " l=" << l << std::endl;
}

int run(int maxlen) 
{
	int CMIN = (int)'A', CMAX = (int)'z', NC = CMAX-CMIN;
	int j, k, l;
	l = NC*255;
	if (maxlen < l)
		l = maxlen;
	l = l / NC + 1;
	if (l > 255)
		l = 255;
	// ---------- std::string list ----------
	sli.clear();
	string e;
	e.resize(256);
	j = 0;
	while (j < maxlen) {
		for (k = 0; k < l; k++)
			e[k] = (char)(j+CMIN);
		e[l] = 0;
		RandSString(rand(), e);
		sli.push_back(e);
		++j;
	}
	RunOne(bm_sort, "Sorting std::list of string", l);
	// ---------- std::wstring list ----------
	wsli.clear();
	wstring we;
	we.resize(256);
	j = 0;
	while (j < maxlen) {
		for (k = 0; k < l; k++)
			we[k] = (wchar_t)(j+CMIN);
		we[l] = 0;
		RandString(rand(), we);
		wsli.push_back(we);
		++j;
	}
	RunOne(bm_wsort, "Sorting std::list of wstring", l);
	// ---------- int list ----------
	ili.clear();
	j = 0;
	int il;
	while (j < maxlen) {
		il = (maxlen - 1) / 256;
		il = rand();
		ili.push_back(il);
		++j;
	}
	RunOne(bm_isort, "Sorting std::list of int", l);
	return 0;
};

int main()
{
	run(100000);
	run(300000);
	run(1000000);
	run(3000000);
	return 0;
}