#include <windows.h>
#include <iostream>
#include <map>
#include <string>

using namespace std;

union FTime {
	FILETIME ft;
	long long lv;
};

map<string, int> smap;
map<wstring, int> wsmap;
int maxlen;

typedef void (*BmProc)(void);

void RandString(int irand, wstring &srnd)
{
	const int CM = 50, NC = 200, NMAX = NC+CM;
	srnd.resize(256);
	int j = 0;
	while (irand != 0) {
		srnd[j] = (wchar_t)(irand % NC + CM);
		++j;
		irand = irand / NC;
	}
}

void RandSString(int irand, string &srnd)
{
	const int CM = 50, NC = 200, NMAX = NC+CM;
	srnd.resize(256);
	int j = 0;
	while (irand != 0) {
		srnd[j] = (char)(irand % NC + CM);
		++j;
		irand = irand / NC;
	}
}

void RunOne(BmProc prc, const char *name, int sz)
{
	FTime t0, t1;
	GetSystemTimeAsFileTime(&t0.ft);
	(*prc)();
	GetSystemTimeAsFileTime(&t1.ft);
	std::cout << name << " t=" << (t1.lv-t0.lv)/10 << " mcs size=" << sz << std::endl;
}

void run1s()
{
	int CMIN = (int)'A', CMAX = (int)'z', NC = CMAX-CMIN;
	int j, k, l;
	string s;
	s.resize(256);
	l = NC*255;
	if (maxlen < l)
		l = maxlen;
	l = l / NC + 1;
	if (l > 255)
		l = 255;
	j = 0;
	while (j < maxlen) {
		/*for (k = 0; k < l; k++)
			s[k] = (char)(j+CMIN);
		s[l] = 0;*/
		RandSString(rand(), s);
		smap[s] = j;
		++j;
	}
}

void run1w()
{
	int CMIN = (int)'A', CMAX = (int)'z', NC = CMAX-CMIN;
	int j, k, l;
	wstring w;
	w.resize(256);
	l = NC*255;
	if (maxlen < l)
		l = maxlen;
	l = l / NC + 1;
	if (l > 255)
		l = 255;
	j = 0;
	while (j < maxlen) {
		/*for (k = 0; k < l; k++)
			w[k] = (wchar_t)(j+CMIN);
		w[l] = 0;*/
		RandString(rand(), w);
		wsmap[w] = j;
		++j;
	}
}

int run(int mlen) 
{
	maxlen = mlen;
	RunOne(run1s, "Making char string map", mlen);
	RunOne(run1w, "Making wchar_t string map", mlen);
	return 0;
};

int main()
{
	run(100000);
	run(300000);
	run(1000000);
	run(3000000);
	return 0;
}